#Clase Dieta que representa un menú dietético genérico.
class Dieta
	
	
	#Módulo Comparable
	include Comparable

	#Titulo de la dieta	
	attr_accessor :titulo 
	#Ingesta diaria de la dieta
	attr_accessor :ing_diaria
	#Platos que constituyen la dieta
	attr_accessor :platos 
	#Valor calórico total de la dieta
	attr_accessor :vct 
	#Porcentaje de proteínas de un conjunto de platos
	attr_accessor :prot
	#Porcentaje de grasas de un conjunto de platos
	attr_accessor :grasas
	#Porcentaje de hidratos de carbono de un conjunto de platos
	attr_accessor :carbo


	#Inicializa los atributos
	def initialize(titulo, ing_diaria, platos, vct, prot, grasas, carbo)

	    @titulo = titulo
	    @ing_diaria = ing_diaria
	    @platos = platos
	    @vct = vct
	    @prot = prot
	    @grasas = grasas
	    @carbo = carbo

	end
	
	#Imprime la dieta con el formato adecuado
	def to_s

	    title = "#{@titulo} (#{@ing_diaria})\n"

	    for i in 0..@platos.size-1
	      title+="-#{@platos[i][0]}, #{@platos[i][1]}, #{@platos[i][2]}\n"
	    end

	    title += "V.C.T. | %\t#{@vct} | #{@prot} - #{@grasas} - #{@carbo}"
	end	

	#Permite a los objetos de la clase Dieta (o sus hijas) compararse con otros objetos de la clase Dieta (o sus hijas)
	def <=> (another)

		vct.delete(' kcal').to_f <=> another.vct.delete(' kcal').to_f

	end

end
