#Clase Dieta_dsl.
class Dieta_dsl

	#Módulo Comparable
	include Comparable
	
	#Etiqueta de la dieta	
	attr_accessor :etiqueta
	#Titulo de la dieta	
	attr_accessor :titulo
	#Ingesta diaria de la dieta
	attr_accessor :ing_diaria
	#Platos que constituyen la dieta
	attr_accessor :platos 
	#Valores de los porcentajes de la dieta
	attr_accessor :porcentajes

	#Inicializa los atributos
	def initialize(etiqueta, &block)
		
		@etiqueta = etiqueta
		@titulo = "SIN TITULO"
		@ing_diaria = []
		@platos = []
		@porcentajes = []
	
		if block_given?  
			if block.arity == 1
				yield self
			else
				instance_eval(&block) 
			end
		end
	end

	#Titulo
	def tit(name)
		
		@titulo = name
	end

	#Ingesta diaria
	def i_d(options = {})
		
		i_d = []
		i_d << "#{options[:min]}" if options[:min]
		i_d << "#{options[:max]}" if options[:max]
		
		@ing_diaria = i_d
	end

	#Platos
	def plat(options = {})
		
		plat = []
		plat << "#{options[:descripcion]}" if options[:descripcion]
		plat << "#{options[:porcion]}" if options[:porcion]
		plat << "#{options[:gramos]}" if options[:gramos]		
		
		@platos << plat
	end
	
	#Porcentajes
	def porc(options = {})
		
		porc = []
		porc << "#{options[:vct]}" if options[:vct]
		porc << "#{options[:proteinas]}" if options[:proteinas]
		porc << "#{options[:grasas]}" if options[:grasas]
		porc << "#{options[:hidratos]}" if options[:hidratos]		
				
		@porcentajes = porc
	end

	#Imprime la dieta con el formato adecuado
	def to_s
		
	    title = "#{@etiqueta}\n#{@titulo} (#{@ing_diaria[0]}% - #{@ing_diaria[1]}%)\n"

	    for i in 0..@platos.size-1
	      title+="-#{@platos[i][0]}, #{@platos[i][1]}, #{@platos[i][2]} g\n"
	    end

	    title += "V.C.T. | %\t#{@porcentajes[0]} kcal | #{@porcentajes[1]}% - #{@porcentajes[2]}% - #{@porcentajes[3]}%"
	end

	#Permite a los objetos de la clase (o sus hijas) compararse con otros objetos de la clase (o sus hijas)
	def <=> (another)

		@porcentajes[0].to_f <=> another.porcentajes[0].to_f

	end	

end
