
#Struct que representa un nodo de una lista simplemente enlazada, con el valor que contiene y un puntero al siguiente nodo de la lista
Node = Struct.new(:value, :next)

#Clase Lista que representa una lista simplemente enlazada.
class Lista
	
	#Puntero al nodo cabeza de la lista
	attr_reader :head
	
	#Inicializa la cabeza a nil, para poder tener una lista vacía, sin nodos
	def initialize 
	
		@head = nil

	end
	
	#Permite introducir un elemento de cualquier tipo en la lista, e internamente se creará un nodo y se meterá por la cabeza
	def push (*elementos)
		
		elementos.each do |i|
			
			nodo = Node.new(i, @head)
			@head = nodo
		end

	end

	#Permite sacar un elemento de la lista por la cabeza, devolviendo el valor del nodo y no el nodo en sí, y eliminando el nodo
	def pop 
		
		nodo = @head
		@head = @head.next
		return nodo.value
				
	end
	
	#Indica si la lista está vacía o no
	def is_empty?

		if @head==nil
			return true
		else 
			return false

		end
	end
	
	#Imprime la lista con el formato adecuado, elemento por elemento, desde la cabeza en adelante
	def to_s
		
		nodo = @head
		cadena = ""
		cont = 1
		
		while nodo!=nil do
			cadena += "#{cont}) #{nodo.value}\n"
			nodo = nodo.next
			cont+=1
		end	

		cadena
	end


end
